[![Python CI/CD](https://github.com/Arkko002/NotificationNtBot/actions/workflows/python-package.yml/badge.svg)](https://github.com/Arkko002/NotificationNtBot/actions/workflows/python-package.yml)

## Installation

``` 
pip install ntpubbot
```

## Usage

Before usage bot needs to be configured with your Discord Bot token.

All the config values have defaults set in code, and on first run of the bot those will be accessible in 
$HOME/.config/ntpubbot/config.json

Bot detects missing fields in the config, and if it encounters one it will write the default value to make up for it.

### What it does
1. Roles:
    * You can get and remove the pinging role from yourself by reacting to the monitored message. (Agiel's message in #welcome)
    * Bot will only ping the role if number of active players exceeds "min_ping_player" config value.


2. Messages:
    * Update messages will be posted in a channel specified by "channel_id".
    * Bot will ping the role only if players on any server exceed "min_ping_players" and "ping_timeout" has passed.
    * To reduce spam bot will edit its own last message with new information, but only if it's the last message in the channel,
    and only if ping is not required (edits don't trigger pings correctly).


### Commands
```
!channel <channel name> - Sets channel used to post updates

!role <role name> - Sets role that will be pinged

!min_ping <number> - Sets minimum players for ping update

!min_players <number> - Sets minimum players for update without ping

!timeout <number> - Sets ping timeout period to seconds provided as argument
```

The values provided in commands need to be plain names of the entities on a server. So no @my-role or #my-channel,
just their names (this is probably going to change in the future).

Values provided directly through config.json need to be ID of the channel and role, you can obtain them by right clicking
on the entities in discord and clicking "Copy ID".
